// Define the pins connected to the encoder
#define ENCODER_PIN_A 22
#define ENCODER_PIN_B 18
#define ENCODER_BUTTON_PIN 19

// Variables to store encoder state
volatile int encoderPosition = 0;
volatile bool A_set = false;
volatile bool B_set = false;
bool up = false;
void setup() {
  // Initialize serial communication for debugging
  Serial.begin(9600);

  // Set encoder pins as inputs
  pinMode(ENCODER_PIN_A, INPUT);
  pinMode(ENCODER_PIN_B, INPUT);
  pinMode(ENCODER_BUTTON_PIN, INPUT_PULLUP);


  // Attach interrupts to the encoder pins
  // attachInterrupt(digitalPinToInterrupt(ENCODER_PIN_A), readEncoder, CHANGE);
  // attachInterrupt(digitalPinToInterrupt(ENCODER_PIN_B), readEncoder, CHANGE);

  attachInterrupt(digitalPinToInterrupt(ENCODER_PIN_A), isr0, FALLING);
  attachInterrupt(digitalPinToInterrupt(ENCODER_BUTTON_PIN), button, CHANGE);
}

void loop() {
  // Print the encoder position to the serial monitor
  Serial.print("Encoder Position: ");
  Serial.println(encoderPosition);
  delay(100);
}

// Interrupt service routine for encoder pin A
// void readEncoder() {
//   // Read the state of both encoder pins
//   A_set = digitalRead(ENCODER_PIN_A) == HIGH;
//   B_set = digitalRead(ENCODER_PIN_B) == HIGH;

//   // Determine the direction of rotation
//   if (A_set != B_set) {
//     encoderPosition++;
//   } else {
//     encoderPosition--;
//   }
// }

void isr0() {
  // TurnDetected = true;
  up = (digitalRead(ENCODER_PIN_A) == digitalRead(ENCODER_PIN_B));
  if (up) {
    encoderPosition++;
  } else {
    encoderPosition--;
  }
}

void button() {
  Serial.println("Button pressed");
}
