void setup() {
  // Start serial communication
  Serial.begin(115200);
  while (!Serial) {
    ; // Wait for serial port to connect. Needed for native USB port only
  }
  Serial.println("Enter the number to divide 360 by:");
}

void loop() {
  // Check if data is available to read
  if (Serial.available() > 0) {
    // Read the input number
    int x = Serial.parseInt();

    // Check if the input number is valid
    if (x > 0) {
      // Create an array to hold the angles
      int angles[x];

      // Populate the array with divided angles
      for (int i = 0; i < x; i++) {
        angles[i] = (360 / x) * i;
      }

      // Shuffle the array
      shuffleArray(angles, x);

      // Print the shuffled angles
      Serial.println("Shuffled angles:");
      for (int i = 0; i < x; i++) {
        Serial.println(angles[i]);
      }
    } else {
      Serial.println("Please enter a valid number greater than 0.");
    }

    // Clear the input buffer
    while (Serial.available() > 0) {
      Serial.read();
    }

    // Prompt for next input
    Serial.println("Enter the number to divide 360 by:");
  }
}

// Function to shuffle an array using Fisher-Yates algorithm
void shuffleArray(int array[], int n) {
  for (int i = n - 1; i > 0; i--) {
    int j = random(0, i + 1); // Generate a random number between 0 and i
    // Swap array[i] with the element at random index
    int temp = array[i];
    array[i] = array[j];
    array[j] = temp;
  }
}
