// Define the step and direction pins for the Y-axis
#define Y_STEP_PIN 3
#define Y_DIR_PIN 2
#define Y_ENABLE_PIN 8

const int stepsPerRevolution = 200;  // Adjust this to fit your motor's specifications

void setup() {
  // Set the step and direction pins as outputs
  pinMode(Y_STEP_PIN, OUTPUT);
  pinMode(Y_DIR_PIN, OUTPUT);
  pinMode(Y_ENABLE_PIN, OUTPUT);

  // Enable the stepper motor driver (typically LOW to enable)
  digitalWrite(Y_ENABLE_PIN, LOW);

  // Initialize the serial port
  Serial.begin(9600);
}

void loop() {
  // Step one revolution in one direction
  Serial.println("Clockwise");
  stepMotor(stepsPerRevolution, HIGH);
  delay(500);

  // Step one revolution in the other direction
  Serial.println("Counterclockwise");
  stepMotor(stepsPerRevolution, LOW);
  delay(500);
}

// Function to step the motor
void stepMotor(int steps, bool direction) {
  // Set the direction
  digitalWrite(Y_DIR_PIN, direction);

  for (int i = 0; i < steps; i++) {
    digitalWrite(Y_STEP_PIN, HIGH);
    delayMicroseconds(2000);  // Adjust delay for speed control
    digitalWrite(Y_STEP_PIN, LOW);
    delayMicroseconds(2000);  // Adjust delay for speed control
  }
}
